/*
 * Copyright (C) 2016 LNLS (www.lnls.br)
 * Author: Lucas Russo <lucas.russo@lnls.br>
 *
 * Released according to the GNU GPL, version 3 or any later version.
 */

#include "sm_io_exports_helper.h"
#include "sm_io_codes.h"

/* Description SMIO TRIGGER_MUX functions */

disp_op_t trigger_mux_rcv_src_exp = {
    .name = TRIGGER_MUX_NAME_RCV_SRC,
    .opcode = TRIGGER_MUX_OPCODE_RCV_SRC,
    .retval = DISP_ARG_ENCODE(DISP_ATYPE_UINT32, uint32_t),
    .retval_owner = DISP_OWNER_OTHER,
    .args = {
        DISP_ARG_ENCODE(DISP_ATYPE_UINT32, uint32_t),
        DISP_ARG_ENCODE(DISP_ATYPE_UINT32, uint32_t),
        DISP_ARG_ENCODE(DISP_ATYPE_UINT32, uint32_t),
        DISP_ARG_END
    }
};

disp_op_t trigger_mux_rcv_in_sel_exp = {
    .name = TRIGGER_MUX_NAME_RCV_IN_SEL,
    .opcode = TRIGGER_MUX_OPCODE_RCV_IN_SEL,
    .retval = DISP_ARG_ENCODE(DISP_ATYPE_UINT32, uint32_t),
    .retval_owner = DISP_OWNER_OTHER,
    .args = {
        DISP_ARG_ENCODE(DISP_ATYPE_UINT32, uint32_t),
        DISP_ARG_ENCODE(DISP_ATYPE_UINT32, uint32_t),
        DISP_ARG_ENCODE(DISP_ATYPE_UINT32, uint32_t),
        DISP_ARG_END
    }
};

disp_op_t trigger_mux_transm_src_exp = {
    .name = TRIGGER_MUX_NAME_TRANSM_SRC,
    .opcode = TRIGGER_MUX_OPCODE_TRANSM_SRC,
    .retval = DISP_ARG_ENCODE(DISP_ATYPE_UINT32, uint32_t),
    .retval_owner = DISP_OWNER_OTHER,
    .args = {
        DISP_ARG_ENCODE(DISP_ATYPE_UINT32, uint32_t),
        DISP_ARG_ENCODE(DISP_ATYPE_UINT32, uint32_t),
        DISP_ARG_ENCODE(DISP_ATYPE_UINT32, uint32_t),
        DISP_ARG_END
    }
};

disp_op_t trigger_mux_transm_out_sel_exp = {
    .name = TRIGGER_MUX_NAME_TRANSM_OUT_SEL,
    .opcode = TRIGGER_MUX_OPCODE_TRANSM_OUT_SEL,
    .retval = DISP_ARG_ENCODE(DISP_ATYPE_UINT32, uint32_t),
    .retval_owner = DISP_OWNER_OTHER,
    .args = {
        DISP_ARG_ENCODE(DISP_ATYPE_UINT32, uint32_t),
        DISP_ARG_ENCODE(DISP_ATYPE_UINT32, uint32_t),
        DISP_ARG_ENCODE(DISP_ATYPE_UINT32, uint32_t),
        DISP_ARG_END
    }
};

/* Exported function description */
const disp_op_t *trigger_mux_exp_ops [] = {
    &trigger_mux_rcv_src_exp,
    &trigger_mux_rcv_in_sel_exp,
    &trigger_mux_transm_src_exp,
    &trigger_mux_transm_out_sel_exp,
    NULL
};

